package com.hzya.frame.plugin.lets.dingtalk.dao.impl;

import com.hzya.frame.plugin.lets.dingtalk.entity.DingU8cBillEntity;
import com.hzya.frame.plugin.lets.dingtalk.dao.IDingU8cBillDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;
import com.hzya.frame.basedao.dao.MybatisGenericDao;

import java.util.Date;
import java.util.List;

/**
 * (DingU8cBill)表数据库访问层
 *  ->Y
 *  ->N
 * N->N
 * N->Y
 * Y->Y
 * @author makejava
 * @since 2024-10-28 15:45:32
 */
@Repository("dingU8cBillDao")
public class DingU8cBillDaoImpl extends MybatisGenericDao<DingU8cBillEntity, String> implements IDingU8cBillDao{

//    private IDingU8cBillDao dingU8cBillDao;
//    @Override
//    public void saveOrUpDateV2(DingU8cBillEntity dingU8cBillEntityNew) {
//        DingU8cBillEntity dingU8cBill = new DingU8cBillEntity();
//        String u8cCodeCorp = dingU8cBillEntityNew.getU8cCodeCorp();
//        String u8cBillCode = dingU8cBillEntityNew.getU8cBillCode();
//        String u8cBillId = dingU8cBillEntityNew.getU8cBillId();
//        String dingTalkProcessId = dingU8cBillEntityNew.getDingTalkProcessId();
//        dingU8cBill.setU8cCodeCorp(u8cCodeCorp);
//        dingU8cBill.setU8cBillCode(u8cBillCode);
//        dingU8cBill.setU8cBillId(u8cBillId);
//        dingU8cBill.setDingTalkProcessId(dingTalkProcessId);
//        dingU8cBill.setSts("Y");
//        List<DingU8cBillEntity> query = this.query(dingU8cBill);
//        if (query.size() == 0) {
//            //->N
//            //->Y
//            this.save(dingU8cBillEntityNew);
//        }else {
//            DingU8cBillEntity dingU8cBillEntity = query.get(0);
//            String pushStatus = dingU8cBillEntity.getPushStatus();
//            String pushStatusNew = dingU8cBillEntityNew.getPushStatus();
//            if("N".equals(pushStatus)&&"N".equals(pushStatusNew)){
//                //N->N
//                dingU8cBill.setId(dingU8cBillEntity.getId());
//                dingU8cBill.setModify_time(new Date());
//                dingU8cBill.setPushStatus("N");
//                dingU8cBill.setPushInfo(dingU8cBillEntityNew.getPushInfo());
//                this.update(dingU8cBill);
//            }else if("N".equals(pushStatus)&&"Y".equals(pushStatusNew)){
//                //N->Y
//                dingU8cBill.setId(dingU8cBillEntity.getId());
//                dingU8cBill.setDingTalkProcessId(dingU8cBillEntityNew.getDingTalkProcessId());
//                dingU8cBill.setModify_time(new Date());
//                dingU8cBill.setPushStatus("Y");
//                dingU8cBill.setPushInfo(dingU8cBillEntityNew.getPushInfo());
//                this.update(dingU8cBill);
//            }else if("Y".equals(pushStatus)&&"Y".equals(pushStatusNew)){
//                //Y->Y
//                dingU8cBill.setId(dingU8cBillEntity.getId());
//                dingU8cBill.setModify_time(new Date());
//                dingU8cBill.setDing_res(dingU8cBillEntityNew.getDing_res());
//                dingU8cBill.setApprove(dingU8cBillEntityNew.getApprove());
//                this.update(dingU8cBill);
//            }
//        }
//    }

    /**
     * 根据：公司、单据号、实例id、来源D|U
     * @param dingU8cBillEntityNew
     */
    @Override
    public void saveOrUpDateV2(DingU8cBillEntity dingU8cBillEntityNew) {
        DingU8cBillEntity dingU8cBill = new DingU8cBillEntity();
        dingU8cBill.setU8cCodeCorp(dingU8cBillEntityNew.getU8cCodeCorp());//公司
        dingU8cBill.setU8cBillCode(dingU8cBillEntityNew.getU8cBillCode());//单据号
        dingU8cBill.setDingTalkProcessId(dingU8cBillEntityNew.getDingTalkProcessId());//实例id
        dingU8cBill.setInitiate(dingU8cBillEntityNew.getInitiate());//来源平台
        List<DingU8cBillEntity> query = this.query(dingU8cBill);
        if(query.size()==0){
            //->N
            //->Y
            this.save(dingU8cBillEntityNew);
        }else {
            DingU8cBillEntity dingU8cBillEntity = query.get(0);
            String pushStatus = dingU8cBillEntity.getPushStatus();
            String pushStatusNew = dingU8cBillEntityNew.getPushStatus();
            if("N".equals(pushStatus)&&"N".equals(pushStatusNew)){
                //N->N
                dingU8cBill.setId(dingU8cBillEntity.getId());
                dingU8cBill.setDingTalkProcessId(dingU8cBillEntityNew.getDingTalkProcessId());
                dingU8cBill.setModify_time(new Date());
                dingU8cBill.setPushStatus("N");
                dingU8cBill.setPushInfo(dingU8cBillEntityNew.getPushInfo());
                this.update(dingU8cBill);
            } else if ("N".equals(pushStatus)&&"Y".equals(pushStatusNew)) {
                //N->Y
                dingU8cBill.setId(dingU8cBillEntity.getId());
                dingU8cBill.setDingTalkProcessId(dingU8cBillEntityNew.getDingTalkProcessId());
                dingU8cBill.setModify_time(new Date());
                dingU8cBill.setPushStatus("Y");
                dingU8cBill.setPushInfo(dingU8cBillEntityNew.getPushInfo());
                this.update(dingU8cBill);
            } else if ("Y".equals(pushStatus)&&"Y".equals(pushStatusNew)) {
                //Y->Y
                dingU8cBill.setId(dingU8cBillEntity.getId());
                dingU8cBill.setDingTalkProcessId(dingU8cBillEntityNew.getDingTalkProcessId());
                dingU8cBill.setModify_time(new Date());
                dingU8cBill.setDing_res(dingU8cBillEntityNew.getDing_res());
                dingU8cBill.setApprove(dingU8cBillEntityNew.getApprove());
                dingU8cBill.setPushInfo(dingU8cBillEntityNew.getPushInfo());
                this.update(dingU8cBill);
            }
        }
    }
}

