package com.hzya.frame.plugin.lets.util;

import com.hzya.frame.WebappApplication;
import com.hzya.frame.ttxofs.dto.ofssalesordersearch.DetailsDto;
import com.hzya.frame.ttxofs.dto.ofssalesordersearch.HeaderDetailsDto;
import com.hzya.frame.ttxofs.dto.ofssalesordersearch.HeaderDto;
import com.hzya.frame.ttxofs.dto.ofssalesordersearch.SaleOrderMessageDto;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.ArrayList;
import java.util.List;

import static org.junit.Assert.*;

/**
 * @Author：liuyang
 * @Package：com.hzya.frame.plugin.lets.util
 * @Project：kangarooDataCenterV3
 * @name：OfsOrderSalePostageFeeAllocationUtilTest
 * @Date：2024/10/23 14:51
 * @Filename：OfsOrderSalePostageFeeAllocationUtilTest
 */
@RunWith(SpringRunner.class)
@SpringBootTest(classes = WebappApplication.class)
public class OfsOrderSalePostageFeeAllocationUtilTest {

    @Autowired
    private OfsOrderSalePostageFeeAllocationUtil ofsOrderSalePostageFeeAllocationUtil;

    @Autowired
    private AfterSalesOrderUtil afterSalesOrderUtil;

    @Test
    public void batchTocSalesPostageFeeAllocation() {
        try {
            SaleOrderMessageDto ofsOrder = afterSalesOrderUtil.getOfsOrder("LETS-SO2024100100026431");
            List<HeaderDetailsDto> data = ofsOrder.getData();

//            List<HeaderDetailsDto> headerDetailsDtoList = new ArrayList<>();
//            headerDetailsDtoList.add(HeaderDetailsDto.builder().build());
            ofsOrderSalePostageFeeAllocationUtil.batchTocSalesPostageFeeAllocation(data);

            HeaderDetailsDto headerDetailsDto = data.get(0);
            HeaderDto header = headerDetailsDto.getHeader();
            List<DetailsDto> details = headerDetailsDto.getDetails();
            for (int i = 0; i < details.size(); i++) {
                DetailsDto detailsDto = details.get(i);
                System.out.println("邮费分摊比例：" + detailsDto.getPostageFeeSharingRatio());
                System.out.println("原始运费分摊金额：" + detailsDto.getOriginalFreightDiscounts());
                System.out.println("实际运费分摊金额：" + detailsDto.getShareTargetFreightDiscounts());
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Test
    public void tocSalesPostageFeeAllocation() {
    }
}